<script lang="ts">
	import { slide } from 'svelte/transition';
	import { db } from '$lib/firebase/firebase';
	import { collection, getDocs, addDoc, setDoc, doc } from 'firebase/firestore';
	import { onMount } from 'svelte';
	import type { Category, CategoryInput } from './type';
	import Button from '../../../../components/Button.svelte';
	import AddCategory from './_components/AddCategory.svelte';
	import CategoryDetail from './_components/CategoryDetail.svelte';
	import ChangeCategoriesOrder from './_components/ChangeCategoriesOrder.svelte';
	import ProductsList from '../../../(app)/produit/_components/ProductsList.svelte';

	let categories: Category[] = [];
	const getCategories = async () => {
		categories = [];
		const docRef = await getDocs(collection(db, 'categories'));
		docRef.forEach((doc) => {
			categories.push({ ...doc.data(), id: doc.id } as Category);
		});
		categories = categories;
		categories.sort((a, b) => a.order - b.order);
	};

	const addCategory = async (e: any) => {
		const categoryInput: CategoryInput = e.detail.newCat;

		// We edit
		if (categoryInput.id) {
			const docRef = doc(db, 'categories', categoryInput.id);
			await setDoc(docRef, e.detail.newCat, { merge: true });
			await getCategories();
			showAddCategorie = false;
		} else {
			// We create
			const docRef = collection(db, 'categories');
			await addDoc(docRef, { ...e.detail.newCat, order: categories.length });
			await getCategories();
			showAddCategorie = false;
		}
	};

	const refreshCategories = async () => {
		await getCategories();
	};

	onMount(() => {
		getCategories();
	});

	let showAddCategorie = false;
	let showEditOrder = false;

	let preview = false;
</script>

<!-- <img src={link} alt="" class="aspect-square w-60" /> -->
<div class="flex flex-col gap-2 p-4">
	{#if !showAddCategorie}
		<div class="flex gap-2 items-center">
			{#if !showEditOrder}
				<Button
					on:click={() => {
						showAddCategorie = !showAddCategorie;
					}}
				>
					Ajouter une categorie
				</Button>
			{/if}
			<Button
				type="secondary"
				on:click={() => {
					showEditOrder = !showEditOrder;
				}}
			>
				{#if showEditOrder}
					Retour
				{:else}
					Modifier l'ordre
				{/if}
			</Button>
			<!-- <Button
				type="secondary"
				on:click={() => {
					preview = !preview;
				}}
			>
				Prévisualiser
			</Button>
			<Button
				type="secondary"
				on:click={() => {
					location.reload();
				}}
			>
				Reset
			</Button> -->
		</div>
	{/if}
	{#if preview}
		<div class="w-full h-full" transition:slide>
			<ProductsList />
		</div>
	{:else}
		{#if showEditOrder}
			<ChangeCategoriesOrder {categories} on:refresh={getCategories} />
		{:else}
			{#each categories as category, catIndex}
				<CategoryDetail
					{category}
					index={catIndex}
					on:deleteCategory={refreshCategories}
					on:add={addCategory}
				/>
			{/each}
		{/if}
		<AddCategory on:add={addCategory} bind:show={showAddCategorie} />
	{/if}
</div>
